#ifndef MAKECFG_HH 
#define MAKECFG_HH 

#include "u64.hh"
#include <list>
#include <set>
#include <map>
#include "symboltable.hh"


class CFG_Edge ;
class CFG_Vertex ;

enum BType { BT_None , BT_Unconditional , BT_Conditional , 
                BT_Serialising } ;

class Make_CFG
{
public:
    Make_CFG () ;
    virtual ~Make_CFG () ;
    void Read_Trace ( FILE * ftr0fd ,
            ulongint main_start , ulongint main_end ,
            FILE * exe_trace_out = 0L ) ;
    void Make () ;
    void Unmake () ;
    void Export ( FILE * outfd ) ;
    void Export_UDG ( FILE * udgf , Symbol_Table * symtab ) ;


private:
    std::set<ulongint>                          bb_mark ;
    std::unordered_map<ulongint, ulongint>      fall_through ;
    std::unordered_map<ulongint, ulongint>      exec_frequency ;
    std::unordered_map<ulongint, BType>         branch_type ;
    std::unordered_map<ulongint, ulongint>      cost_lookup ;
    std::unordered_map<ulongint, ulongint>      repeat_lookup ;
    std::unordered_map<ulongint, 
            std::map<ulongint, ulongint> >      branch_links ;

    std::list<CFG_Edge *>           all_cfg_edges ;
    std::list<CFG_Vertex *>         all_cfg_vertexes ;
    CFG_Vertex *                    entrance ;

} ;

#endif

